/*
	Column.cpp
*/

#include "stdafx.h"
#include "LiteX.h"
#include "Column.h"

HRESULT CLiteColumn::Init(ILiteStatement *_pStmt, LONG nIndex)
{
	CComPtr<ILiteStatement> pStmt( _pStmt );
	m_nIndex = nIndex;
	HRESULT hRes = pStmt->get_ColumnName( nIndex, &m_bsName );
	return S_OK;
}

HRESULT CLiteColumn::CreateObject( ILiteStatement* pStmt, LONG nIndex, IDispatch** ppColumn)
{
	typedef CComObject<CLiteColumn> _class;
	HRESULT hRes = E_POINTER;
	if (ppColumn != NULL)
	{
		*ppColumn = NULL;
		_class* p;
		hRes = _class::CreateInstance(&p);
		if (SUCCEEDED(hRes))
		{
			// If this object has ownership of the data then we need to keep it around
			hRes = p->Init(pStmt,nIndex);
			if (SUCCEEDED(hRes))
			{
				hRes = p->_InternalQueryInterface( IID_IDispatch, (void**)ppColumn);
			}
			
			if (FAILED(hRes))
			{
				delete p;
			}
		}
	}
	return hRes;
}


STDMETHODIMP CLiteColumn::get_Index(LONG* pVal)
{
	if ( pVal == NULL )
	{
		return E_POINTER;
	}

	*pVal = m_nIndex;
	return S_OK;
}

STDMETHODIMP CLiteColumn::get_Value(BSTR* pVal)
{
	if ( pVal == NULL )
	{
		return E_POINTER;
	}
	
	*pVal = m_bsName.Copy();
	return S_OK;
}
