/*
	Column.h
*/

#ifndef __LITECOLUMN_H
#define __LITECOLUMN_H

#include "LiteX.h"

// CLiteColumn

class ATL_NO_VTABLE CLiteColumn :
	public CComObjectRootEx<CComObjectThreadModel>,
	public CComCoClass<CLiteColumn, &CLSID_LiteColumn>,
	public IDispatchImpl<ILiteColumn, &IID_ILiteColumn, &LIBID_LITEXLib>,
	public IProvideClassInfo2Impl<&CLSID_LiteColumn, NULL, &LIBID_LITEXLib>	
{

public:

	CLiteColumn()
	{
		m_nIndex = -1;
	}
	
	HRESULT Init( ILiteStatement* pStmt, LONG nIndex );
	static HRESULT CreateObject( ILiteStatement*, LONG, IDispatch** );


	DECLARE_NOT_AGGREGATABLE(CLiteColumn)

	BEGIN_COM_MAP(CLiteColumn)
		COM_INTERFACE_ENTRY(ILiteColumn)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY(IProvideClassInfo)
		COM_INTERFACE_ENTRY(IProvideClassInfo2)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	
public:

	// ILiteColumn
	STDMETHOD(get_Index)(LONG* pVal);
	STDMETHOD(get_Value)(BSTR* pVal);

protected:

	LONG m_nIndex;
	CComBSTR m_bsName;
	
};

#endif

