/*
	Columns.h
*/

#ifndef __LITECOLUMNS_H
#define __LITECOLUMNS_H

#include "LiteX.h"

class ATL_NO_VTABLE CLiteColumnsEnum :public 
	CComSAEnum<IEnumVARIANT, &IID_IEnumVARIANT, IDispatch*, VARIANT >
{
	public:
	
	static HRESULT CreateObject( SAFEARRAY* sa, IUnknown* pUnk, IUnknown** ppEnum )
	{
		typedef CComObject<CLiteColumnsEnum> _class;
		HRESULT hRes = E_POINTER;
		if (ppEnum != NULL)
		{
			*ppEnum = NULL;
			_class* p;
			hRes = _class::CreateInstance(&p);
			if (SUCCEEDED(hRes))
			{
				// If this object has ownership of the data then we need to keep it around
				hRes = p->Init(sa,NULL,AtlFlagCopy);
				if (SUCCEEDED(hRes))
				{
					hRes = p->_InternalQueryInterface( IID_IUnknown, (void**)ppEnum);
				}
				
				if (FAILED(hRes))
				{
					delete p;
				}
			}
		}
		return hRes;
	} 
};


class ATL_NO_VTABLE CLiteColumns :
	public CComObjectRootEx<CComObjectThreadModel>,
	public CComCoClass<CLiteColumns, &CLSID_LiteColumns>,
	public ISupportErrorInfo,
	public IDispatchImpl<ILiteColumns, &IID_ILiteColumns, &LIBID_LITEXLib>,
	public IProvideClassInfo2Impl<&CLSID_LiteColumns, NULL, &LIBID_LITEXLib>	
{
public:

	CLiteColumns()
	{
	}
	
	HRESULT Init( ILiteStatement* );
	static HRESULT CreateObject( ILiteStatement*, IDispatch** );	

DECLARE_NOT_AGGREGATABLE(CLiteColumns)

BEGIN_COM_MAP(CLiteColumns)
	COM_INTERFACE_ENTRY(ILiteColumns)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		m_sa = NULL;
		m_nCount = 0;
		return S_OK;
	}

	void FinalRelease()
	{
		if ( m_sa != NULL )
		{
			SafeArrayDestroy( m_sa );
		}
	}

public:

	// ILiteColumns
	STDMETHOD(get__NewEnum)(IUnknown** pVal);
	STDMETHOD(get_Item)( VARIANT vIndex, IDispatch* *pVal);
	STDMETHOD(get_Count)(LONG* pVal);
	
protected:

	CComPtr<ILiteStatement> m_pStmt;
	SAFEARRAY* m_sa;
	LONG m_nCount;
	
	HRESULT litex_error( HRESULT ) const;
};


#endif
