/*
	Parameter.cpp
*/

#include "stdafx.h"
#include "Parameter.h"

STDMETHODIMP CLiteParameter::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ILiteParameter
	};

	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (IsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

HRESULT CLiteParameter::Init(ILiteStatement *pStmt, LONG nIndex)
{
	m_pStmt = pStmt;
	m_nIndex = nIndex;
	return S_OK;
}

HRESULT CLiteParameter::CreateObject( ILiteStatement* pStmt, LONG nIndex, IDispatch** ppParam)
{
	typedef CComObject<CLiteParameter> _class;
	HRESULT hRes = E_POINTER;
	if (ppParam != NULL)
	{
		*ppParam = NULL;
		_class* p;
		hRes = _class::CreateInstance(&p);
		if (SUCCEEDED(hRes))
		{
			// If this object has ownership of the data then we need to keep it around
			hRes = p->Init(pStmt,nIndex);
			if (SUCCEEDED(hRes))
			{
				hRes = p->_InternalQueryInterface( IID_IDispatch, (void**)ppParam);
			}
			
			if (FAILED(hRes))
			{
				delete p;
			}
		}
	}
	return hRes;
}


STDMETHODIMP CLiteParameter::get_Index(LONG* pVal)
{
	if ( pVal == NULL )
	{
		return E_POINTER;
	}

	*pVal = m_nIndex;
	return S_OK;
}

STDMETHODIMP CLiteParameter::get_Name(BSTR* pVal)
{
	HRESULT hRes = m_pStmt->get_ParameterName( m_nIndex+1, pVal );
	return hRes;
}

STDMETHODIMP CLiteParameter::Bind(VARIANT vValue, LxTypeEnum eType)
{
	CComVariant idx( m_nIndex+1 );
	HRESULT hRes = m_pStmt->BindParameter( idx, vValue, eType );
	return hRes;
}
