/*
	Parameter.h
*/

#ifndef __LITEPARAMETER_H
#define __LITEPARAMETER_H

#include "LiteX.h"

class ATL_NO_VTABLE CLiteParameter :
	public CComObjectRootEx<CComObjectThreadModel>,
	public CComCoClass<CLiteParameter, &CLSID_LiteParameter>,
	public ISupportErrorInfo,
	public IDispatchImpl<ILiteParameter, &IID_ILiteParameter, &LIBID_LITEXLib>,
	public IProvideClassInfo2Impl<&CLSID_LiteParameter, NULL, &LIBID_LITEXLib>
{
public:

	CLiteParameter()
	{
		m_nIndex = -1;
	}
	
	HRESULT Init( ILiteStatement* pStmt, LONG nIndex );
	static HRESULT CreateObject( ILiteStatement*, LONG, IDispatch** );


DECLARE_NOT_AGGREGATABLE(CLiteParameter)

BEGIN_COM_MAP(CLiteParameter)
	COM_INTERFACE_ENTRY(ILiteParameter)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}
	
protected:

	CComPtr<ILiteStatement> m_pStmt;
	LONG m_nIndex;

public:

	STDMETHOD(get_Index)(LONG* pVal);
	STDMETHOD(get_Name)(BSTR* pVal);
	STDMETHOD(Bind)(VARIANT vValue, LxTypeEnum eType);
};

#endif
