/*
	Parameters.h
*/

#ifndef __LITEPARAMETERS_H
#define __LITEPARAMETERS_H

#include "LiteX.h"

class ATL_NO_VTABLE CLiteParametersEnum :public 
	CComSAEnum<IEnumVARIANT, &IID_IEnumVARIANT, IDispatch*, VARIANT >
{
	public:
	
	static HRESULT CreateObject( SAFEARRAY* sa, IUnknown* pUnk, IUnknown** ppEnum )
	{
		typedef CComObject<CLiteParametersEnum> _class;
		HRESULT hRes = E_POINTER;
		if (ppEnum != NULL)
		{
			*ppEnum = NULL;
			_class* p;
			hRes = _class::CreateInstance(&p);
			if (SUCCEEDED(hRes))
			{
				// If this object has ownership of the data then we need to keep it around
				hRes = p->Init(sa,pUnk,AtlFlagNoCopy);
				if (SUCCEEDED(hRes))
				{
					hRes = p->_InternalQueryInterface( IID_IUnknown, (void**)ppEnum);
				}
				
				if (FAILED(hRes))
				{
					delete p;
				}
			}
		}
		return hRes;
	} 
};

class ATL_NO_VTABLE CLiteParameters :
	public CComObjectRootEx<CComObjectThreadModel>,
	public CComCoClass<CLiteParameters, &CLSID_LiteParameters>,
	public ISupportErrorInfo,
	public IDispatchImpl<ILiteParameters, &IID_ILiteParameters, &LIBID_LITEXLib>,
	public IProvideClassInfo2Impl<&CLSID_LiteParameters, NULL, &LIBID_LITEXLib>
{
public:

	CLiteParameters()
	{
	}
	
	HRESULT Init( ILiteStatement* );
	static HRESULT CreateObject( ILiteStatement*, IDispatch** );	

DECLARE_NOT_AGGREGATABLE(CLiteParameters)

BEGIN_COM_MAP(CLiteParameters)
	COM_INTERFACE_ENTRY(ILiteParameters)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		m_sa = NULL;
		m_nCount = 0;
		return S_OK;
	}

	void FinalRelease()
	{
		if ( m_sa != NULL )
		{
			SafeArrayDestroy( m_sa );
		}
	}
	
protected:

	CComPtr<ILiteStatement> m_pStmt;
	SAFEARRAY* m_sa;
	LONG m_nCount;
	
	HRESULT litex_error( HRESULT ) const;

public:

	STDMETHOD(get__NewEnum)(IUnknown** pVal);
	STDMETHOD(get_Item)(VARIANT vIndex, IDispatch** pVal);
	STDMETHOD(get_Count)(LONG* pVal);
	STDMETHOD(Bind)(LPSAFEARRAY *params);
};

#endif
