/*
	Row.h
*/

#ifndef __LITEROW_H
#define __LITEROW_H

#include "LiteX.h"

class ATL_NO_VTABLE CLiteRowEnum :public 
	CComSAEnum<IEnumVARIANT, &IID_IEnumVARIANT, VARIANT, VARIANT >
{
	public:
	
	static HRESULT CreateObject( SAFEARRAY* sa, IUnknown* pUnk, IUnknown** ppEnum )
	{
		typedef CComObject<CLiteRowEnum> _class;
		HRESULT hRes = E_POINTER;
		if (ppEnum != NULL)
		{
			*ppEnum = NULL;
			_class* p;
			hRes = _class::CreateInstance(&p);
			if (SUCCEEDED(hRes))
			{
				// If this object has ownership of the data then we need to keep it around
				hRes = p->Init(sa,pUnk,AtlFlagCopy);
				if (SUCCEEDED(hRes))
				{
					hRes = p->_InternalQueryInterface( IID_IUnknown, (void**)ppEnum);
				}
				
				if (FAILED(hRes))
				{
					delete p;
				}
			}
		}
		return hRes;
	} 
};

///

class ATL_NO_VTABLE CLiteRow :
	public CComObjectRootEx<CComObjectThreadModel>,
	public CComCoClass<CLiteRow, &CLSID_LiteRow>,
	public ISupportErrorInfo,	
	public IDispatchImpl<ILiteRow, &IID_ILiteRow, &LIBID_LITEXLib>,
	public IProvideClassInfo2Impl<&CLSID_LiteRow, NULL, &LIBID_LITEXLib>
{
public:

	CLiteRow()
	{
		m_nSize = 0;
		m_sa = NULL;
	}
	
	HRESULT Init( ILiteStatement* );
	
	static HRESULT CreateObject( ILiteStatement*, IDispatch** );

	DECLARE_NOT_AGGREGATABLE(CLiteRow)

	BEGIN_COM_MAP(CLiteRow)
		COM_INTERFACE_ENTRY(ILiteRow)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY(ISupportErrorInfo)		
		COM_INTERFACE_ENTRY(IProvideClassInfo)
		COM_INTERFACE_ENTRY(IProvideClassInfo2)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
		if ( m_sa != NULL )
		{
			SafeArrayDestroy( m_sa );
		}
	}

protected:

	LONG m_nSize;
	SAFEARRAY* m_sa;
	
	HRESULT litex_error( HRESULT ) const;

public:

	// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	// ILiteRow
	STDMETHOD(get_Value)(VARIANT* pVal);
	STDMETHOD(get__NewEnum)(IUnknown** pVal);
	STDMETHOD(get_Item)(LONG nIndex, LxTypeEnum eType, VARIANT* pVal);
	STDMETHOD(get_Count)(LONG* pVal);
};

#endif

