/*
	Rows.h
*/

#ifndef __LITEROWS_H
#define __LITEROWS_H

#include "LiteX.h"

class ATL_NO_VTABLE CLiteRowsEnum :public 
	CComSAEnum<IEnumVARIANT, &IID_IEnumVARIANT, IDispatch*, VARIANT >
{
	public:
	
	static HRESULT CreateObject( SAFEARRAY* sa, IUnknown* pUnk, IUnknown** ppEnum )
	{
		typedef CComObject<CLiteRowsEnum> _class;
		HRESULT hRes = E_POINTER;
		if (ppEnum != NULL)
		{
			*ppEnum = NULL;
			_class* p;
			hRes = _class::CreateInstance(&p);
			if (SUCCEEDED(hRes))
			{
				// If this object has ownership of the data then we need to keep it around
				hRes = p->Init(sa,pUnk);
				if (SUCCEEDED(hRes))
				{
					hRes = p->_InternalQueryInterface( IID_IUnknown, (void**)ppEnum);
				}
				
				if (FAILED(hRes))
				{
					delete p;
				}
			}
		}
		return hRes;
	} 
};


class ATL_NO_VTABLE CLiteRows :
	public CComObjectRootEx<CComObjectThreadModel>,
	public CComCoClass<CLiteRows, &CLSID_LiteRows>,
	public ISupportErrorInfo,
	public IDispatchImpl<ILiteRows, &IID_ILiteRows, &LIBID_LITEXLib>,
	public IProvideClassInfo2Impl<&CLSID_LiteRows, NULL, &LIBID_LITEXLib>	
{
public:

	CLiteRows()
	{
		m_sa = NULL;
		m_bStatic = false;
	}
	
	HRESULT Init( bool, LONG, ILiteStatement*);
	HRESULT Init( SAFEARRAY* );
	
	DECLARE_NOT_AGGREGATABLE(CLiteRows)

	BEGIN_COM_MAP(CLiteRows)
		COM_INTERFACE_ENTRY(ILiteRows)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY(ISupportErrorInfo)
		COM_INTERFACE_ENTRY(IProvideClassInfo)
		COM_INTERFACE_ENTRY(IProvideClassInfo2)
	END_COM_MAP()
	
	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
		if ( m_sa != NULL )
		{
			SafeArrayDestroy( m_sa );
		}
	}	
	
	public:

	// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	// ILiteRwos
	STDMETHOD(get__NewEnum)( /*[out,retval]*/ IUnknown** pUnkEnum );
	STDMETHOD(get_Count)( VARIANT* pVal);
	STDMETHOD(get_Item)(LONG nIndex, IDispatch** pVal);

public:

	static HRESULT CreateObject( bool, LONG, ILiteStatement*, IDispatch** );
	static HRESULT CreateObject( SAFEARRAY*, IDispatch** );
	
protected:

	CComPtr<ILiteStatement> m_pStmt;
	SAFEARRAY* m_sa;
	bool m_bStatic;
	
	HRESULT build_array_of_rows( LONG );
	
};


#endif
