/*
	LiteX BLOB test.
*/

WshShell = new ActiveXObject( "WScript.Shell" );
Fso = new ActiveXObject( "Scripting.FileSystemObject" );
oConnection = new ActiveXObject( "LiteX.LiteConnection" );

function get_blob()
{
	var oStream = new ActiveXObject( "ADODB.Stream" );
	oStream.Type = 1 /*adTypeBinary*/;
	oStream.Open();
	oStream.LoadFromFile( WScript.ScriptFullName );
	return oStream.Read();
}

function get_second_blob()
{
	var oStream = new ActiveXObject( "ADODB.Stream" );
	oStream.Type = 1 /*adTypeBinary*/;
	oStream.Open();
	oStream.LoadFromFile( WScript.FullName );
	return oStream.Read();
}

function save_blob( b )
{
	var oStream = new ActiveXObject( "ADODB.Stream" );
	oStream.Type = 1 /*adTypeBinary*/;
	oStream.Open();
	oStream.Write( b );
	var sFile = Fso.BuildPath( Fso.GetSpecialFolder(2 /*TemporaryFolder*/).Path, "blober.txt" );
	oStream.SaveToFile( sFile );
	oStream.Close();

	WshShell.Run( "notepad " + sFile );
	WScript.Sleep(1000);
	Fso.DeleteFile( sFile );
}

WScript.Echo( "Hello from SQLite version", oConnection.Version, "!" );

sDb = Fso.BuildPath( Fso.GetSpecialFolder(2 /*TemporaryFolder*/).Path, "blob.db" )
oConnection.Path = sDb;
oConnection.Open();

oConnection.Execute("PRAGMA count_changes=1");
oConnection.Execute( "CREATE TABLE Blober(n INTEGER PRIMARY KEY,b BLOB)" );
oBlob = get_blob();

oConnection.Execute( "BEGIN TRANSACTION" );
oStmt = oConnection.Prepare( "INSERT INTO Blober(b) VALUES(?)" );
oStmt.BindParameters( oBlob );
for( i=0; i<5000; i++ )
{
	oStmt.Step();
	oStmt.Reset();
}
oStmt.Close();
oConnection.Execute( "COMMIT TRANSACTION" );

oBlob = get_second_blob();
nRes = oConnection.Execute( "UPDATE Blober SET b=? WHERE n<125", oBlob );
WScript.Echo( nRes, "records were updated." );

oStatement = oConnection.Prepare( "SELECT b,tohex(b,\":\") FROM Blober" );
oStatement.Step(2501);

WScript.Echo( "HEX", oStatement.ColumnValue(1) );
save_blob( oStatement.ColumnValue("b") );
oStatement.Close();
oConnection.Close();

Fso.DeleteFile( sDb );
WScript.Echo( "Test complete." );






