/*
	LiteX simple test.
*/

WshShell = new ActiveXObject( "WScript.Shell" );
Fso = new ActiveXObject( "Scripting.FileSystemObject" );
oDb = new ActiveXObject( "LiteX.LiteConnection" );

WScript.Echo( "Hello from SQLite version",oDb.Version,"!" );
WScript.Echo( "Hello from SQLite version",oDb.Version(false),"again!" );

sDb = Fso.BuildPath( Fso.GetSpecialFolder(2 /*TemporaryFolder*/).Path, "sqlite3.db" )
oDb.Open( sDb );

oDb.Execute( "CREATE TABLE Test( a INTEGER PRIMARY KEY, b INTEGER )" );

nMax = 5000 + Math.round( 5000 * Math.random() );
oDb.Execute( "BEGIN TRANSACTION" );
for( i=0; i<nMax; i++ )
{
	oDb.Execute( "INSERT INTO Test(b) VALUES (?)", Math.round( Math.random() * 10000 ) );
}
oDb.Execute( "COMMIT TRANSACTION" );

WScript.Echo( "Last insert rowid:", oDb.LastInsertRowid );
fAvg = oDb.Execute( "SELECT avg(b) FROM Test" );
WScript.Echo( "Avg value:", fAvg );

result = new VBArray(
	oDb.Execute( "SELECT min(b), max(b) FROM Test WHERE b>?",
		Math.round( Math.random() * 1000 ) ) );
WScript.Echo( "Min value:", result.getItem(0) );
WScript.Echo( "Max value:", result.getItem(1) );

result = oDb.Execute( "DELETE FROM Test WHERE b < ?", fAvg );
WScript.Echo( "Changes:", oDb.Changes );

oStmt = oDb.Prepare( "SELECT * FROM Test" );
WScript.Echo( "Row count:", oStmt.RowCount );
oStmt.Close();

oDb.Execute( "DELETE FROM Test" );
oDb.Execute( "INSERT INTO Test(b) VALUES (?)", 1 );
oDb.Execute( "INSERT INTO Test(b) VALUES (?)", "qqqqqq" );
oDb.Execute( "INSERT INTO Test(b) VALUES (NULL)" );

oStmt = oDb.Prepare( "SELECT * FROM Test" );
WScript.Echo( "Row count again:", oStmt.Rows(true).Count );
oStmt.Close();

oDb.Close();
Fso.DeleteFile( sDb );
WScript.Echo( "Test complete." );

