/*
	LiteX simple test.
*/

WshShell = new ActiveXObject( "WScript.Shell" );
Fso = new ActiveXObject( "Scripting.FileSystemObject" );
oDb = new ActiveXObject( "LiteX.LiteConnection" );
oDb.ProgressPeriod = 0;
nProgress = 0
bInterrupt = false

function litex_Error()
{
	WScript.Echo( "Error!" )
}

// event handling
function litex_Progress()
{
	WScript.Echo( "Progress event was raised",nProgress,"time(s).");
	nProgress++;
	if ( bInterrupt && (nProgress>50) )
	{
		WScript.Echo( "Interrrupting!" );
		oDb.Interrupt();
	}
	return false; // doesn't wok, cannot pass value back
}

// this way we can connect only to ILiteProgress interface
WScript.ConnectObject( oDb, "litex_" )

WScript.Echo( "Hello from SQLite version",oDb.Version,"!" );


sDb = Fso.BuildPath( Fso.GetSpecialFolder(2 /*TemporaryFolder*/).Path, "sqlite3.db" )
if ( Fso.FileExists( sDb ) )
{
	Fso.DeleteFile( sDb );
}
oDb.Open( sDb );

oDb.Execute( "CREATE TABLE Test( a INTEGER PRIMARY KEY, b TEXT COLLATE unaccented, c INTEGER, d FLOAT )" );
oDb.Execute( "CREATE INDEX b ON Test( b ASC )" );

oDb.Execute( "BEGIN TRANSACTION" );
for( i=0; i<1000; i++ )
{
	oDb.Execute( "INSERT INTO Test( b, c, d ) VALUES (?,?,:three)",
		"ӥ:" + i,
		Math.round( Math.random() * 100000 ),
		Math.random() );
	oDb.Execute( "INSERT INTO Test( b, c, d ) VALUES (?,?,:three)",
		"󹜳z:"+i,
		Math.round( Math.random() * 100000 ),
		Math.random() );

}
oDb.Execute( "COMMIT TRANSACTION" );

sFile = Fso.BuildPath( Fso.GetSpecialFolder(2 /*TemporaryFolder*/).Path, "table.txt" )
f = Fso.CreateTextFile( sFile, true, true );
f.WriteLine("Hello from LiteX test!");

oStmt = oDb.Prepare( "SELECT a,unaccent(b),c,d FROM Test ORDER BY c, b DESC" );
while( !oStmt.Step() )
{
	f.WriteLine( oStmt.ColumnValue("a") + "\t" + oStmt.ColumnValue(1) +
		"\t" + oStmt.ColumnValue("c") + "\t" + oStmt.ColumnValue(3) );
}

WScript.Echo( "Interruptiing from event." )
nProgress = 0
bInterrupt = true
oDb.ProgressPeriod = 100
try
{
	oDb.Execute( "SELECT avg(c) FROM Test" )
}
catch( e )
{
	WScript.Echo( e )
	WScript.Echo( "Number: ", e.number>>16 & 0x1FFF, e.number & 0xFFFF );
	WScript.Echo( "Message:", e.message );
	WScript.Echo( "Description:", e.description );
	WScript.Echo( e )

}
finally
{
	oDb.ProgressPeriod = 0
}

WScript.Echo( "Cleaning up." )
WScript.DisconnectObject(oDb)
f.Close();
oStmt.Close();
oDb.Close();
Fso.DeleteFile( sDb );

WshShell.Run( sFile );
WScript.Sleep(1000);
Fso.DeleteFile( sFile );

WScript.Echo( "Test complete." );

