/*
	LiteX simple statement test.
*/

WshShell = new ActiveXObject( "WScript.Shell" );
Fso = new ActiveXObject( "Scripting.FileSystemObject" );
oDb = new ActiveXObject( "LiteX.LiteConnection" );

WScript.Echo( "Hello from SQLite version",oDb.Version,"!" );
WScript.Echo( "Please do not run this script using WScript interpreter. Use CScript instead." );

// in-memory database
oDb.OpenInMemory();

oStmt = new ActiveXObject( "LiteX.LiteStatement" );
oStmt.ActiveConnection = oDb;
oStmt.CommandText = "CREATE TABLE Test( i INTEGER PRIMARY KEY,a, b, c )";
oStmt.Prepare();
oStmt.Execute();
oStmt.Close();

oStmt.CommandText = "INSERT INTO Test(a,b,c) VALUES (:one,?,:three)";
oStmt.Prepare();
WScript.Echo( "Number of parameters:", oStmt.ParameterCount );
WScript.Echo( "Parameter names:", oStmt.ParameterName(1), "'", oStmt.ParameterName(2), "'", oStmt.ParameterName(3) );

for( i=0; i<10000; i++ )
{
	oStmt.BindParameters( "String #" + i, Math.random() * 10000,  (Math.random() < 0.5)? null : i );
	oStmt.Step();
	oStmt.Reset();
}
oStmt.Close();

oStmt.CommandText = "SELECT i,a AS 'Hello from a' ,b AS 'Hello from b', c AS 'Hello from c' FROM Test ORDER BY b DESC";
oStmt.Prepare();
while ( !oStmt.Step() )
{
	WScript.Echo("Index ",oStmt.ColumnValue(0));
	WScript.Echo( oStmt.ColumnName(1),":", oStmt.ColumnValue("Hello from a") );
	WScript.Echo( oStmt.ColumnName(2),":", oStmt.ColumnValue("Hello from b") );
	WScript.Echo( oStmt.ColumnName(3),":", oStmt.ColumnValue("Hello from c") );
	WScript.Echo("");
}
oStmt.Close();

oDb.Close();

WScript.Echo( "Test complete." );
