/*
	LiteX simple statement test.
*/

WshShell = new ActiveXObject( "WScript.Shell" );
Fso = new ActiveXObject( "Scripting.FileSystemObject" );
oDb = new ActiveXObject( "LiteX.LiteConnection" );

WScript.Echo( "Hello from SQLite version",oDb.Version,"!" );

oDb.Open( Fso.BuildPath( Fso.GetSpecialFolder(2 /*TemporaryFolder*/).Path, "sqlite3.db" ) );
oDb.BatchExecute("CREATE TABLE Test1(a,b,c);CREATE INDEX idx1 ON Test1(b);CREATE TABLE Test2(a,b,c);CREATE INDEX idx2 ON Test2(b)");

oStmt = new ActiveXObject( "LiteX.LiteStatement" );
oStmt.ActiveConnection = oDb;
oStmt.CommandText = "INSERT INTO Test1(a,b,c) VALUES (:one,?,:three)";
oStmt.Prepare();
WScript.Echo( "Number of parameters:", oStmt.ParameterCount );
WScript.Echo( "Parameter names:", oStmt.ParameterName(1), "'", oStmt.ParameterName(2), "'", oStmt.ParameterName(3) );

for( i=0; i<10; i++ )
{
	oStmt.BindParameter( ":one", "Ala ma kota: " + i );
	oStmt.BindParameter( 2, Math.random() * 10 );
	oStmt.BindParameter( ":three", (Math.random() < 0.5)? null : i );
	oStmt.Step();
	oStmt.Reset();
}
oStmt.Close();

oDb.BatchExecute( "BEGIN TRANSACTION" )
oStmt.CommandText = "INSERT INTO Test2(a,b,c) VALUES (:one,?,:three)";
oStmt.Prepare();

oColumns = oStmt.Columns;
oCEnum = new Enumerator( oColumns ); // zero elements but able to eneumerate
for (;!oCEnum.atEnd();oCEnum.moveNext())
{
	oColumn = oCEnum.item();
	WScript.Echo( "COLUMN", oColumn.Index, "->", oColumn.Value, "!!!" );
}
oCEnum = 0
oColumns = 0

WScript.Echo( "Number of parameters:", oStmt.ParameterCount );
WScript.Echo( "Parameter names:", oStmt.ParameterName(1), "'", oStmt.ParameterName(2), "'", oStmt.ParameterName(3) );
for( i=0; i<201; i++ )
{
	oStmt.BindParameter( ":one", "Ala ma kota: " + i );
	oStmt.BindParameter( 2, Math.random() * 10 );
	oStmt.BindParameter( ":three", (Math.random() < 0.5)? null : i );
	oStmt.Execute();
}
oStmt.Close();
oDb.BatchExecute( "COMMIT TRANSACTION" )

oStmt.CommandText = "SELECT a AS 'Test1.a' ,b AS 'Test1.b', c AS 'Test1.c' FROM Test1 ORDER BY b DESC";
oStmt.Prepare();
while ( !oStmt.Step() )
{
	WScript.Echo( oStmt.ColumnName(0),":", oStmt.ColumnValue("Test1.a") );
	WScript.Echo( oStmt.ColumnName(1),":", oStmt.ColumnValue("Test1.b") );
	WScript.Echo( oStmt.ColumnName(2),":", oStmt.ColumnValue("Test1.c") );
}
oStmt.Close();

oStmt.CommandText = "SELECT a AS 'Test2.a' ,b AS 'Test2.b', c AS 'Test2.c' FROM Test2 ORDER BY b DESC LIMIT 30";
try
{
	oColumns = oStmt.Columns;
	
	oCEnum = new Enumerator( oColumns );
	for (;!oCEnum.atEnd();oCEnum.moveNext())
	{
		oColumn = oCEnum.item();
		WScript.Echo( "Column", oColumn.Index, "->", oColumn.Value );
	}
	oCEnum = 0
	
	oRows = oStmt.Rows(true,20); // try to set to true or false
	oEnum = new Enumerator( oRows )
	
	WScript.Echo( "Row count:", oRows.Count );
	
	for (;!oEnum.atEnd();oEnum.moveNext())
	{
		oRow = oEnum.item()
		
		for( i=0; i<oRow.Count; i++ )
		{
			WScript.Echo(  oColumns(i) , ":", oRow(i) );
		}
	}
}
catch( e )
{
	WScript.Echo( e )
	WScript.Echo( "Number: ", e.number>>16 & 0x1FFF, e.number & 0xFFFF );
	WScript.Echo( "Message:", e.message );
	WScript.Echo( "Description:", e.description );
	WScript.Echo( e )
}

oStmt.Close();

oDb.Close();
Fso.DeleteFile( oDb.Path );

WScript.Echo( "Test complete." );
