/*
	LiteX simple test.
*/

PL_PATTERN = "󥹌";

function create_pl_string()
{
	var s = new String();
	var i;

	for( i=0; i<PL_PATTERN.length; i++ )
	{
		s += PL_PATTERN.charAt( Math.round( Math.random() * PL_PATTERN.length ) );
	}

	return s;
}

WshShell = new ActiveXObject( "WScript.Shell" );
Fso = new ActiveXObject( "Scripting.FileSystemObject" );
oDb = new ActiveXObject( "LiteX.LiteConnection" );

WScript.Echo( "Hello from SQLite version",oDb.Version,"!" );

sDb = Fso.BuildPath( Fso.GetSpecialFolder(2 /*TemporaryFolder*/).Path, "sqlite3.db" )
oDb.Open( sDb );

oDb.Execute( "CREATE TABLE Unacc( a INTEGER PRIMARY KEY, b TEXT COLLATE unaccented)" );
oDb.Execute( "CREATE INDEX b ON Unacc( b ASC )" );
oDb.Execute( "PRAGMA temp_store = MEMORY" );

oDb.Execute( "BEGIN TRANSACTION" );
for( i=0; i<2000; i++ )
{
	oDb.Execute( "INSERT INTO Unacc(b) VALUES (?)", create_pl_string() );
}
oDb.Execute( "COMMIT TRANSACTION" );

sFile = Fso.BuildPath( Fso.GetSpecialFolder(2 /*TemporaryFolder*/).Path, "table.txt" )
f = Fso.CreateTextFile( sFile, true, true );

oStmt = oDb.Prepare( "SELECT ROWID, unaccent(b) AS UNACC, b FROM Unacc ORDER BY b" );
while( !oStmt.Step() )
{
	f.WriteLine( oStmt.ColumnValue(0) + "\t" + oStmt.ColumnValue("unacc") + "\t" + oStmt.ColumnValue(2) );
}
f.Close();

oStmt.Close();
oDb.Close();
Fso.DeleteFile( sDb );

WshShell.Run( sFile );
WScript.Sleep(1000);
Fso.DeleteFile( sFile );

WScript.Echo( "Test complete." );

